#! /usr/bin/python
# wget http://www.pin1.org/download/py/p017/p017A.py
# wget http://www.pin1.org/download/py/sv3A.py

 
import p017A     # LCD class
from sv3A import sv3Bus
import sys
import platform
import time
import os
import glob

def getCPUtemperature():
    res = os.popen('vcgencmd measure_temp').readline()
    return res

#initiate the temperature sensor
os.system('modprobe w1-gpio')
os.system('modprobe w1-therm')
 
#set up the location of the sensor in the system
base_dir = '/sys/bus/w1/devices/'
device_folder = glob.glob(base_dir + '28*')[0]
device_file = device_folder + '/w1_slave'

def read_temp_raw():
    f = open(device_file, 'r')
    lines = f.readlines()
    f.close()
    return lines
 
def read_temp():
    lines = read_temp_raw()
    while lines[0].strip()[-3:] != 'YES':
        time.sleep(0.2)
        lines = read_temp_raw()
    equals_pos = lines[1].find('t=')
    if equals_pos != -1:
        temp_string = lines[1][equals_pos+2:]
        temp_c = float(temp_string) / 1000.0
        temp_f = temp_c * 9.0 / 5.0 + 32.0
        return temp_c


def lcd_test(bottom,top):#funtion to initialize the display bottom and top are strings passed to the function and will display on the screen.
    bus = sv3Bus(int(0),'1',"")
    adr = 56
    lcd = p017A.p017(bus,int(adr))
    value = 0
    lcd.cls()
    lcd.bl(0,0,10)
    msg = top
    lcd.lcd(msg)
    lcd.rc(1,0)
    msg = bottom[:15]
    lcd.lcd(msg)

intro = "Welcome to the basicdual temp display program\n\
This script prints the cpu temp\n\
and the temp from a DS18B20 temp probe\n\
It will loop every min and print to the screen too"

print intro
loop = 0
while True: #infinite loop
    loop = loop+1
    cputemp=getCPUtemperature()
    bottom="CPU Temp ="+cputemp[5:9] + "'C "#line 1 on LCD
    top = "Out Temp "+str(read_temp())
    #top = raw_input ("What would you like on the top line -   ")
    #bottom = raw_input ("what would you like on the bottom line -   ")
    #top and bottom can be what ever u want as long as they are less than 16 characters long.
    print " loop number " + str(loop)
    print top
    print
    print bottom
    lcd_test(bottom,top)

    time.sleep(60) #wait 1 minute
