#! /usr/bin/python
# wget http://www.pin1.org/download/py/p017/p017A.py
# wget http://www.pin1.org/download/py/sv3A.py

 
import p017A     # LCD class
from sv3A import sv3Bus
import sys
import platform
import time
import os
import datetime
import socket
import MySQLdb
import glob

def getCPUtemperature():
    res = os.popen('vcgencmd measure_temp').readline()
    return res

#initiate the temperature sensor
os.system('modprobe w1-gpio')
os.system('modprobe w1-therm')
 
#set up the location of the sensor in the system
base_dir = '/sys/bus/w1/devices/'
device_folder = glob.glob(base_dir + '28*')[0]
device_file = device_folder + '/w1_slave'

def write_db(tempdb,timedb,datedb):
    db = MySQLdb.connect(host="localhost", user="root", passwd="milligan", db="temp")
    cursor = db.cursor()
    sql = """INSERT INTO logging(temp,time,date)VALUES (%s,%s,%s)"""
    try:
       # Execute the SQL command
       cursor.execute(sql,(tempdb,timedb,datedb))
       # Commit your changes in the database
       db.commit()
    except:
       # Rollback in case there is any error
       db.rollback()

    # disconnect from server
    db.close()

def read_temp_raw():
    f = open(device_file, 'r')
    lines = f.readlines()
    f.close()
    return lines
 
def read_temp():
    lines = read_temp_raw()
    while lines[0].strip()[-3:] != 'YES':
        time.sleep(0.2)
        lines = read_temp_raw()
    equals_pos = lines[1].find('t=')
    if equals_pos != -1:
        temp_string = lines[1][equals_pos+2:]
        temp_c = float(temp_string) / 1000.0
        temp_f = temp_c * 9.0 / 5.0 + 32.0
        return temp_c


def lcd_display(bottom,top,red,green,blue):#funtion to initialize the display bottom and top are strings passed to the function and will display on the screen.
    bus = sv3Bus(int(0),'1',"")
    adr = 56
    lcd = p017A.p017(bus,int(adr))
    value = 0
    lcd.cls()
    lcd.bl(red,green,blue)
    msg = top
    lcd.lcd(msg)
    lcd.rc(1,0)
    msg = bottom[:15]
    lcd.lcd(msg)

def convert_temp(temp):
    temp_int = int(temp)
    return temp_int
        
    

intro = "Welcome to the basicdual temp display program\n\
This script prints the cpu temp\n\
and the temp from a DS18B20 temp probe\n\
It will loop every min and print to the screen too"

print intro
loop = 0
while True: #infinite loop
    loop = loop+1
    cputemp=getCPUtemperature()
    bottom="CPU Temp = "+cputemp[5:9] + "'C "#line 1 on LCD
    top = "Out Temp = "+str(read_temp())
    outTemp = str(read_temp())
    mytime = str(datetime.datetime.now().time())
    mydate = str(datetime.datetime.now().date())
    write_db(outTemp,mytime,mydate)
    print " loop number " + str(loop)
    print top
    print
    print bottom

    
    
    value_str = str(read_temp())
    
    #value_int1 = int(value_str[:2])
    value_float = float(value_str)
    value_int = int(value_float) 

    
    if (0 <= value_int <=18):
        red = 0
        green = 0
        blue = 10
    elif (18 <= value_int <=25):
        red = 0
        green = 10
        blue = 0
    elif (25 <= value_int <=35):
        red = 10
        green = 0
        blue = 0

    lcd_display(bottom,top,red,green,blue)

    time.sleep(60) #wait 1 minute
